<template>
	<div class="container mt-5">
		<div class="row">
			<div class="col-md-12">
				<div class="card border-0 rounded shadow">
					<div class="card-body">
						<h4>TAMBAH BUKU</h4>
						<hr />
						<form @submit.prevent="store">
							<div class="form-group">
								<label
									for="title"
									class="font-weight-bold"
									>TITLE</label
								>
								<input
									type="text"
									class="form-control"
									v-model="buku.judul"
									placeholder="Masukkan Judul Buku"
								/>
								<!-- validation -->
								<div
									v-if="validation.judul"
									class="mt-2 alert alert-danger"
								>
									{{ validation.judul[0] }}
								</div>
							</div>
							<div class="form-group">
								<label
									for="content"
									class="font-weight-bold"
									>CONTENT</label
								>
								<input
									type="text"
									class="form-control"
									v-model="buku.sampul"
									placeholder="Masukkan Sampul File"
								/>
								<!-- validation -->
								<div
									v-if="validation.sampul"
									class="mt-2 alert alert-danger"
								>
									{{ validation.sampul[0] }}
								</div>
							</div>
							<div class="form-group">
								<label
									for="content"
									class="font-weight-bold"
									>Penerbit</label
								>
								<select
									class="form-select"
									aria-label="Default select example"
									v-model="buku.penerbit_id"
									v-if="publishers.length > 0"
								>
									<option
										selected
										disabled
										:value="0"
									>
										Pilih Penerbit
									</option>
									<option
										v-for="item in publishers"
										:key="item.id"
										:value="item.id"
									>
										{{ item.nama }}
									</option>
								</select>

								<div
									v-if="validation.sampul"
									class="mt-2 alert alert-danger"
								>
									{{ validation.sampul[0] }}
								</div>
							</div>

							<hr />
							<div class="form-group">
								<button
									type="submit"
									class="btn btn-primary"
								>
									SIMPAN
								</button>
							</div>
						</form>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import { reactive, ref } from 'vue';
import { useRouter } from 'vue-router';
import axios from 'axios';

export default {
	setup() {
		//state posts
		const buku = reactive({
			judul: '',
			sampul: '',
			penerbit_id: 0,
		});

		//state validation
		const validation = ref([]);
		const publishers = ref([]);

		//vue router
		const router = useRouter();

		// fetch publishers
		async function fetchPublishers() {
			try {
				const { data, status } = await axios.get(
					'http://localhost:8000/api/penerbit'
				);
				if (status === 200) {
					console.log(data);
					publishers.value = data;
				}
			} catch (err) {
				console.error(err);
			}
		}
		fetchPublishers();

		//method store
		function store() {
			let judul = buku.judul;
			let sampul = buku.sampul;
			let penerbit_id = buku.penerbit_id;
			axios
				.post('http://localhost:8000/api/buku', {
					judul: judul,
					sampul: sampul,
					penerbit_id: penerbit_id,
				})
				.then(() => {
					//redirect ke post index
					router.push({
						name: 'buku.index',
					});
				})
				.catch((error) => {
					//assign state validation with error
					validation.value = error.response.data;
				});
		}

		//return
		return {
			buku,
			validation,
			router,
			store,
			publishers,
		};
	},
};
</script>
<style>
body {
	background: lightgray;
}
</style>
